// nes.h
//
// cc65@wikiɌfڂkihon.h̓eɗ̓}N{傢o[W
// nes.cƃyAŎgB
#ifndef NES_H_INCLUDED
#define NES_H_INCLUDED

#define SCREEN_W 256
#define SCREEN_H 240

#define NUMBEROF(_array) (sizeof(_array)/sizeof(_array[0]))

/////////////////////////////////////////////////////////////////////////////////
// 2010.11.30 ver 0.14
// ςȂĂȂ肨DɂǂB
// -----------------------------------------------------------------------------
// cc65@wiki
// http://www34.atwiki.jp/cc65/
/////////////////////////////////////////////////////////////////////////////////
#define REGIST_PPU_CTRL1 ((char*)0x2000)
#define REGIST_PPU_CTRL2 ((char*)0x2001)
#define REGIST_PPU_STS   ((char*)0x2002)
#define REGIST_SPR_ADR   ((char*)0x2003)
#define REGIST_SPR_GRA   ((char*)0x2004)
#define REGIST_SCROLL    ((char*)0x2005)
#define REGIST_ADR       ((char*)0x2006)
#define REGIST_GRA       ((char*)0x2007)
#define REGIST_DMA       ((char*)0x4014)
#define JOYPAD           ((char*)0x4016)

#define BG_NAME_HADR(hadr, seg)    ((unsigned char)(hadr+seg))
#define BG_NAME_LADR(ladr, seg)    ((unsigned char)(ladr))

#define BG1_NAME_HADR(seg) BG_NAME_HADR(0x20,seg)
#define BG1_NAME_LADR(seg) BG_NAME_LADR(0x00,seg)
#define BG2_NAME_HADR(seg) BG_NAME_HADR(0x24,seg)
#define BG2_NAME_LADR(seg) BG_NAME_LADR(0x00,seg)
#define BG3_NAME_HADR(seg) BG_NAME_HADR(0x28,seg)
#define BG3_NAME_LADR(seg) BG_NAME_LADR(0x00,seg)
#define BG4_NAME_HADR(seg) BG_NAME_HADR(0x2c,seg)
#define BG4_NAME_LADR(seg) BG_NAME_LADR(0x00,seg)

#define BG1_ATTR_HADR    0x23
#define BG1_ATTR_LADR    0xc0
#define BG2_ATTR_HADR    0x27
#define BG2_ATTR_LADR    0xc0
#define BG3_ATTR_HADR    0x2b
#define BG3_ATTR_LADR    0xc0
#define BG4_ATTR_HADR    0x2f
#define BG4_ATTR_LADR    0xc0

#define BTN_A            0x80
#define BTN_B            0x40
#define BTN_SELECT       0x20
#define BTN_START        0x10
#define BTN_UP           0x08
#define BTN_DOWN         0x04
#define BTN_LEFT         0x02
#define BTN_RIGHT        0x01
#define GUN_TRIGGER      0x10
#define GUN_HIT          0x08
#define MIC_USE          0x04

#define DMA_SPR_TBL      7
#define SPR_ATTR_TBL     ((char *)(DMA_SPR_TBL << 8))

#define SCREEN_MAX       4

enum {
	BTN_STAT_PRESS = 0,
	BTN_STAT_DOWN,
	BTN_STAT_UP,
	BTN_STAT_MAX
};

#define PLAYER_MAX 2

extern unsigned char padinfo[PLAYER_MAX][BTN_STAT_MAX];
extern unsigned char padother;
extern unsigned char dma_cnt;
extern const unsigned int screens[SCREEN_MAX];

//Rg[mF
#define CheckPad(msg) \
{ \
	unsigned char i, j; \
	unsigned char p, c; \
	unsigned char ret; \
	*JOYPAD = 1; \
	*JOYPAD = 0; \
	padother= 0; \
	for(i = 0; i < 2; i++) { \
		p = padinfo[i][BTN_STAT_PRESS]; \
		c = 0; \
		for(j = 0; j < 8; j++) { \
			ret = *(JOYPAD + i); \
			c <<= 1; \
			c |= ret & 0x01; \
			padother |= ret & 0x0f; \
		} \
		padinfo[i][BTN_STAT_PRESS] =  c; \
		padinfo[i][BTN_STAT_DOWN ] =  c & ~p; \
		padinfo[i][BTN_STAT_UP   ] = ~c &  p; \
	} \
}

//{^ςȂ@player:0=1P , 1=2P
#define ButtonPress(player, btn) \
	(padinfo[player][BTN_STAT_PRESS] & btn)

//{^
#define ButtonDown(player, btn) \
	(padinfo[player][BTN_STAT_DOWN] & btn)

//{^
#define ButtonUp(player, btn) \
	(padinfo[player][BTN_STAT_UP] & btn)

//}CNEeȂ
#define ControlOther(btn) \
	(padother & btn)

// PPURg[WX^̏
#define InitPPU(msg) \
	*REGIST_PPU_CTRL1 = 0x00; \
	*REGIST_PPU_CTRL2 = 0x00;

// PPURg[WX^̐ݒ
#define SetPPU(flag1, flag2) \
	*REGIST_PPU_CTRL1 = flag1; \
	*REGIST_PPU_CTRL2 = flag2;

// XN[ݒ
#define SetScroll(x, y) \
	*REGIST_SCROLL = x; \
	*REGIST_SCROLL = y;

//wiݒiJԂj
#define FillBackground(address1, address2, val, cnt) \
{ \
	unsigned char i; \
	*REGIST_ADR = address1; \
	*REGIST_ADR = address2; \
	for (i = 0; i < cnt; i++) *REGIST_GRA = val; \
}

#define FillBackground256(address1, address2, val) \
{ \
	unsigned char i = 0; \
	*REGIST_ADR = address1; \
	*REGIST_ADR = address2; \
	do { *REGIST_GRA = val; } while ( ++i );\
}

//wiݒ
#define SetBackground(address1, address2, bg, cnt) \
{ \
	unsigned char i; \
	*REGIST_ADR = address1; \
	*REGIST_ADR = address2; \
	for (i = 0; i < cnt; i++) *REGIST_GRA = bg[i]; \
}

#define SetBackground256(address1, address2, bg) \
{ \
	unsigned char i = 0; \
	*REGIST_ADR = address1; \
	*REGIST_ADR = address2; \
	do { *REGIST_GRA = bg[i++]; } while ( i ); \
}
#define SetBackground192(address1, address2, bg) \
{ \
	unsigned char i; \
	*REGIST_ADR = address1; \
	*REGIST_ADR = address2; \
	for (i = 0; i < 192; i++) *REGIST_GRA = bg[i]; \
}

//WwĩAhXvZ
#define GetBackgroundAddress(screen, x, y, ret) \
{ \
	unsigned int pos = screens[screen]; \
	pos += (y) * 0x20 + (x); \
	*(ret + 0) = (unsigned char)(pos >> 8); \
	*(ret + 1) = (unsigned char)pos; \
}

//WwĩAhXWX^ɐݒ
#define SetBackgroundAddress(screen, x, y) \
{ \
	unsigned int pos = screens[screen]; \
	pos += (y) * 0x20 + (x); \
	*REGIST_ADR = (unsigned char)(pos >> 8); \
	*REGIST_ADR = (unsigned char)pos; \
}

//ẄʒuɔwiLN^ݒ
#define SetBackgroundChar(screen, x, y, ch) \
{ \
	unsigned int pos = screens[screen]; \
	pos += (y) * 0x20 + (x); \
	*REGIST_ADR = (unsigned char)(pos >> 8); \
	*REGIST_ADR = (unsigned char)pos; \
	*REGIST_GRA = ch; \
}

//ݒiJԂj
#define FillAttribute(address1, address2, val, cnt) \
	FillBackground(address1,address2,val,cnt)

//ݒ
#define SetAttribute(address1, address2, atr, cnt) \
	SetBackground(address1,address2,atr,cnt)

//pbgݒ
#define SetPalette(palette, sprite) \
{ \
	char i; \
	*REGIST_ADR = 0x3f; \
	*REGIST_ADR = 0x10 * sprite; \
	for (i = 0; i < 16; i++) *REGIST_GRA = *(palette + i); \
}

//l[e[u̐ݒ
extern void SetNameTbl(const unsigned char *tbl, char x, char y, char w, char h);

//ȈՈkl[e[u̐ݒ
extern void SetCprNameTbl(const unsigned char *tbl, char x, char y, char w, char h, unsigned char ofs);

//l[e[ű`hԂ
extern void FillNameTbl(char x, char y, char w, char h, unsigned char ch);

//XvCgݒ菉
#define InitSprite(msg) \
	*REGIST_SPR_ADR=0x00;

//XvCgݒ
#define SetSprite(x, y, index, flag) \
	*REGIST_SPR_GRA=y; \
	*REGIST_SPR_GRA=index; \
	*REGIST_SPR_GRA=flag; \
	*REGIST_SPR_GRA=x;

//DMA]̈揉
#define InitDMA(msg) \
{ \
	unsigned char i = 0; \
	do { \
		SPR_ATTR_TBL[i++] = 0; \
	} while (i); \
}

//DMA]
extern unsigned char dma_cnt;
#define ResetDMA(msg) \
	dma_cnt = 0;

//DMA]f[^ݒ
#define SetDMA(x, y, index, flag) \
	*(SPR_ATTR_TBL + 0 + dma_cnt)=y    ; \
	*(SPR_ATTR_TBL + 1 + dma_cnt)=index; \
	*(SPR_ATTR_TBL + 2 + dma_cnt)=flag ; \
	*(SPR_ATTR_TBL + 3 + dma_cnt)=x    ; \
	dma_cnt += 4;

//DMA]f[^ݒI
#define SetEndDMA(msg) \
if (dma_cnt) { \
	do { \
		SPR_ATTR_TBL[dma_cnt++] = 0; \
		SPR_ATTR_TBL[dma_cnt++] = 0; \
		SPR_ATTR_TBL[dma_cnt++] = 0; \
		SPR_ATTR_TBL[dma_cnt++] = 0; \
	} while (dma_cnt); \
}

//DMA]
#define SendDMA(msg) \
	*REGIST_DMA = DMA_SPR_TBL;

//VBlank҂
#define VBlank(msg) \
	while (! (*REGIST_PPU_STS & 0x80) );

//VBlankI҂
#define VSync() \
	while ( (*REGIST_PPU_STS & 0x80) );

//Oe҂
#define ZeroSprite(msg) \
	while (  (*REGIST_PPU_STS & 0x40) ); \
	while (! (*REGIST_PPU_STS & 0x40) );

/*
kihon.h̉

    CheckPadFRg[̊mFB{IɖĂяoB
    ButtonDownFꂽ{^̊mFBij
    ButtonPushFꂽ{^̊mFBij
    ControlOtherF}CNEe̊mFB
    InitPPUFPPURg[WX^̏B
    SetPPUFPPURg[WX^̐ݒB
        flag1FPPURg[WX^P̐ݒB
            bit7FVBlankNMIs
            bit6FPPU}X^[/X[uZNg
            bit5FXvCgTCY(0:8x8,1:8x16)
            bit4FBGp^[e[uAhX(0:$0000,1:$1000)
            bit3FXvCgp^[e[uAhX(0:$0000,1:$1000)
            bit2FPPUAhXCNg(0:+1,1:+32)
            bit0,1F\l[e[uAhXԍi00F$2000EA01F$2400EA10F$2800EEA11F$2C00EEj
        flag2FPPURg[WX^Q̐ݒB
            bit5-7Fbit0=1̂ƂwiF/bit0=1̂ƂF
            000:ȂE001:΁E010:E100:(ȊO͕̐s)
            bit4FXvCg\(0:\,1:\)
            bit3FBG\(0:\,1:\)
            bit2FXvCgNbv(0:ʂ̍Whbg\Ȃ,1:NbvȂ)
            bit1FBGNbv(0:ʂ̍Whbg\Ȃ,1:NbvȂ)
            bit0FfBXvC^Cv(0:J[,1:mN)
    SetScrollFwĩXN[B
        xFʒuB
        yFcʒuB
    FillBackgroundFwi̐ݒiJԂjB
        address1Fo͊JnʒuiʂQoCgj
        address2Fo͊JnʒuiʂQoCgj
        valFo͓ei}X̔ԍj
        cntFo͂JԂ
    SetBackgroundFwi̐ݒB
        address1Fo͊JnʒuiʂQoCgj
        address2Fo͊JnʒuiʂQoCgj
             *bgFo͓ẽ|C^
             cntFo͓ẽoCg
    GetBackgroundAddressFWwĩAhXZoB
        screenF(0:E,1:E,2:,3:E)
        xFʒuB
        yFcʒuB
     *retFAhXi[PoCg~Q̔z
    SetPaletteFpbg̐ݒB
      *paletteFpbgẽ|C^
        spriteFOFwippbg@PFXvCgppbg
    FillAttributeFiwiS}X~S}Xɂǂ̃pbggj̐ݒBiJԂj
        address1Fo͐iʂQoCgj
        address2Fo͐iʂQoCgj
        valFo͓e
        cntFo͂JԂ
    SetAttributeFiwiS}X~S}Xɂǂ̃pbggj̐ݒB
        address1Fo͐iʂQoCgj
        address2Fo͐iʂQoCgj
            *atrFo͓ẽ|C^
             cntFo͓ẽoCg
    SetSpriteFXvCg̐ݒB
        firstF1=Pڂ̃XvCg 0=Qڈȍ~
        xFʒu
        yFcʒu
        indexFR}ڂ̉摜\邩
        flagF\@
            7bitF㉺]
            6bitFE]
            5bitFwiɕ\
            0,1bitFpbgԍ
    SetDMAFDMA]BiXvCgp̈̐ݒj
    *addressFXvCgp̈̊JnAhX
        firstF1=Pڂ̃XvCg 0=Qڈȍ~
        x,y,index,flagFSetSpriteƓeB
    SendDMAFDMA]
        addressFXvCgp̈̊JnAhX̎O 0x1=0x0100
    VBlankFVBlank҂B
    ZeroSpriteFOe҂B

SetRegisterESetBackgroundESetAttributeESetPalette͕֋X㕪Ă邾ŁAĂ鏈͓łB
FillBackgroundFillAttributelB
 */
#endif
