#include "nes.h"

#include "logo_ice.h"
#include "logo_baller.h"

// BGppbg
const char palettebg[] = {
	0x30, 0x31, 0x21, 0x11,
	0x30, 0x26, 0x16, 0x05,
	0x30, 0x34, 0x25, 0x15,
	0x0f, 0x31, 0x10, 0x00,
};

// C
void NesMain() {
	unsigned char frame = 0;

	// PPȔ
	InitPPU();

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// pbgݒ
	SetPalette(palettebg, 0);

	// wiݒip^[l[e[uݒj
	FillNameTbl(0, 0, 32, 30, 0);
	SetNameTbl(logo_ice   , 0,  4, logo_ice_W   , logo_ice_H   );
	SetNameTbl(logo_baller, 2, 14, logo_baller_W, logo_baller_H);

	// wiݒ
	FillAttribute(BG1_ATTR_HADR, BG1_ATTR_LADR, 0, 64);

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

	while (1) {

		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		// BG]R}hf[^ݒ
		if (frame == 0) {
			SetCMD((32-18)/2, 22, "PRESS START BUTTON", 18);

		} else if (frame == 128) {
			SetCMD((32-18)/2, 22, "                  ", 18);
		}

		// BG]f[^ݒI
		SetEndCMD();

		++frame;
	}
}

// NMI荞
void NMIProc(void)
{
	// ҂JnmF
	if (CheckSync()) {

		// BG]R}hs
		SendCMD();

		// XN[l̍Đݒ
		ResetScroll();

		// ݒ
		DoneSync();
	}
}
