#include "nes.h"

#include "logo_ice.h"
#include "logo_baller.h"

enum {
	TASK_MESSAGE_IN = 0,
	TASK_BLINK,
	TASK_MESSAGE_OUT,
	TASK_MAX
};

// BGppbg
const char palettebg[] = {
	0x30, 0x31, 0x21, 0x11,
	0x30, 0x26, 0x16, 0x05,
	0x30, 0x34, 0x25, 0x15,
	0x0f, 0x31, 0x10, 0x00,
};

// \bZ[W
const char message[] = "PRESS START BUTTON";

// C
void NesMain() {
	unsigned char frame = 0;
	unsigned char count = 0;
	char task = TASK_MESSAGE_IN;

	// PPȔ
	InitPPU();

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// pbgݒ
	SetPalette(palettebg, 0);

	// wiݒip^[l[e[uݒj
	FillNameTbl(0, 0, 32, 30, 0);
	SetNameTbl(logo_ice   , 0,  4, logo_ice_W   , logo_ice_H   );
	SetNameTbl(logo_baller, 2, 14, logo_baller_W, logo_baller_H);

	// wiݒ
	FillAttribute(BG1_ATTR_HADR, BG1_ATTR_LADR, 0, 64);

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

	while (1) {
		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		switch (task) {
		case TASK_MESSAGE_IN:
			// BG]R}hf[^ݒ
			SetCMD((32-18)/2 + count, 22, &message[count], 1);

			// ^XNImF
			if (++count >= 18) {
				count = 0;
				task = TASK_BLINK;
			}
			break;

		case TASK_BLINK:
			if (frame == 0) {
				// BG]R}hf[^ݒ
				SetCMD((32-18)/2, 22, message, 18);

				// ^XNImF
				if (++count >= 5) {
					count = 0;
					task = TASK_MESSAGE_OUT;
				}

			} else if(frame == 128) {
				// BG]R}hf[^ݒ
				SetCMD((32-18)/2, 22, "                  ", 18);
			}
			break;

		case TASK_MESSAGE_OUT:
			// BG]R}hf[^ݒ
			SetCMD((32-18)/2 + count, 22, " ", 1);

			// ^XNImF
			if (++count >= 18) {
				count = 0;
				task = TASK_MESSAGE_IN;
			}
			break;

		default:
			count = 0;
			task = TASK_MESSAGE_IN;
			break;
		}

		// BG]f[^ݒI
		SetEndCMD();

		++frame;
	}
}

// NMI荞
void NMIProc(void)
{
	// ҂JnmF
	if (CheckSync()) {

		// BG]R}hs
		SendCMD();

		// XN[l̍Đݒ
		ResetScroll();

		// ݒ
		DoneSync();
	}
}
