#include "nes.h"

#include "logo_ice.h"
#include "logo_baller.h"

enum {
	TASK_SCROLL_IN = 0,
	TASK_WAIT,
	TASK_SCROLL_OUT,
	TASK_MAX
};

// BGppbg
const char palettebg[] = {
	0x30, 0x31, 0x21, 0x11,
	0x30, 0x26, 0x16, 0x05,
	0x30, 0x34, 0x25, 0x15,
	0x0f, 0x31, 0x10, 0x00,
};

// \bZ[W
const char message[] = "PRESS START BUTTON";

// C
void NesMain() {
	unsigned char frame = 0;
	unsigned char count = 0;
	char task = TASK_SCROLL_IN;

	// PPȔ
	InitPPU();

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// pbgݒ
	SetPalette(palettebg, 0);

	// wiݒip^[l[e[uݒj
	SetScreenAdr(0);
	FillNameTbl(0, 0, 32, 30, 0);
	SetScreenAdr(1);
	FillNameTbl(0, 0, 32, 30, 0);
	SetNameTbl(logo_ice   , 0,  4, logo_ice_W   , logo_ice_H   );
	SetNameTbl(logo_baller, 2, 14, logo_baller_W, logo_baller_H);
	SetNameTbl(message, (32-18)/2, 22, 18, 1);

	// wiݒ
	FillAttribute(BG1_ATTR_HADR, BG1_ATTR_LADR, 0, 64);

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

	while (1) {
		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		switch (task) {
		case TASK_SCROLL_IN:
			// wi̕\ʒuݒ
			SetScroll(0, count);

			// ^XNImF
			if (++count >= SCREEN_H - 1) {
				count = 255;
				task = TASK_WAIT;
			}
			break;

		case TASK_WAIT:
			// wi̕\ʒuݒ
			SetScroll(0, SCREEN_H - 1);

			// ^XNImF
			if (!count--) {
				count = SCREEN_H - 1;
				task = TASK_SCROLL_OUT;
			}
			break;

		case TASK_SCROLL_OUT:
			// wi̕\ʒuݒ
			SetScroll(0, count);

			// ^XNImF
			if (--count == 0) {
				count = 0;
				task = TASK_SCROLL_IN;
			}
			break;

		default:
			count = 0;
			task = TASK_SCROLL_IN;
			break;
		}

		// BG]f[^ݒI
		SetEndCMD();

		++frame;
	}
}

// NMI荞
void NMIProc(void)
{
	// ҂JnmF
	if (CheckSync()) {

		// BG]R}hs
		SendCMD();

		// XN[l̍Đݒ
		ResetScroll();

		// ݒ
		DoneSync();
	}
}
