#include "nes.h"
#include "chara.h"

// XvCgppbg
const char palettesp[] = {
	0x30, 0x26, 0x30, 0x01,
	0x2c, 0x16, 0x30, 0x25,
	0x0f, 0x29, 0x39, 0x1a,
	0x30, 0x3d, 0x1d, 0x00,
};

// LN^e[u
const char charatable[][4] = {
	{0x01,0x02,0x1f,0x20}, // 
	{0x03,0x04,0x21,0x22}, // ʑOi
	{0x05,0x06,0x23,0x24}, // E
	{0x07,0x08,0x25,0x26}, // EOi
	{0x09,0x0a,0x27,0x28}, // w
	{0x0b,0x0c,0x29,0x2a}, // wʑOi
};

// Aj[Ve[u
const char animetable[][4][2] = {
	{{4, 0x00}, {5,0x00}, {4, 0x00}, {5, 0x40}}, // 
	{{2, 0x40}, {3,0x40}, {2, 0x40}, {3, 0x40}}, // 
	{{0, 0x00}, {1,0x00}, {0, 0x00}, {1, 0x40}}, // 
	{{2, 0x00}, {3,0x00}, {2, 0x00}, {3, 0x00}}, // E
};

// LN^pbgwe[u
const unsigned char charapal[] = {
	0x00,
	0x01,
};

void chara_init(void) {
	// pbgݒ
	SetPalette(palettesp, 1);

	// TODO : ̑KvȂ̂
}

void chara_draw(Chara* chara, unsigned char cnt, unsigned char frame) {
	unsigned char i;

	for (i = 0; i < cnt; ++i) {
		Chara *p = &chara[i];

		const char *anime = animetable[p->dir][frame];
		const char *chara = charatable[anime[0]];
		unsigned char flag = anime[1] | charapal[p->chr];

		// DMA]\ݒ
		if (flag & 0x40) {
			SetDMA(p->x-8, p->y-12, chara[1], flag);
			SetDMA(p->x  , p->y-12, chara[0], flag);
			SetDMA(p->x-8, p->y- 4, chara[3], flag);
			SetDMA(p->x  , p->y- 4, chara[2], flag);

		} else {
			SetDMA(p->x-8, p->y-12, chara[0], flag);
			SetDMA(p->x  , p->y-12, chara[1], flag);
			SetDMA(p->x-8, p->y- 4, chara[2], flag);
			SetDMA(p->x  , p->y- 4, chara[3], flag);
		}
	}
}
