#include "nes.h"
#include "math.h"
#include "chara.h"
#include "map.h"

// C
void NesMain()
{
	unsigned char frame = 0;
	unsigned char scene = 0;

	Chara chara[] = {
		{CHR_BLUE_PENGUIN, 2,  50,  50},
		{CHR_RED_PENGUIN , 2, 150, 150},
		{CHR_SLIME , 2},
		{CHR_SLIME , 2},
		{CHR_SLIME , 2},
		{CHR_WIZARD, 2},
		{CHR_SLIME , 2},
		{CHR_SLIME , 2},
		{CHR_SLIME , 2},
		{CHR_WIZARD, 2},
	};

	// PPȔ
	InitPPU();

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// 
	srand(14, 10, 11);

	// LN^
	chara_init(chara, NUMBEROF(chara));

	// }bv
	map_init(scene);

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

	while (1) {
		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		// DMA]\񏉊
		ResetDMA();

		// Rg[mF
		CheckPad();

		{
			unsigned char c;
			unsigned char i;

			// 4Aj[VJE^
			c = (frame >> 4) & 3;

			// XvCg̕\ʒuύX
			for (i = 0; i < 2; ++i) {
				Chara *p = &chara[i];

				unsigned char x = p->x;
				unsigned char y = p->y;

				// L[͂ɂړ
				if (ButtonPress(i, BTN_RIGHT)) { p->x++; p->dir = 1; }
				if (ButtonPress(i, BTN_LEFT )) { p->x--; p->dir = 3; }
				if (ButtonPress(i, BTN_UP   )) { p->y--; p->dir = 0; }
				if (ButtonPress(i, BTN_DOWN )) { p->y++; p->dir = 2; }

				// Oɂړ
				p->x = p->x + p->dx; p->dx = 0;
				p->y = p->y + p->dy; p->dy = 0;

				// Ŕ肵Ă݂ #1
				{
					unsigned char x0 = p->x - 8;
					unsigned char y0 = p->y - 8;
					unsigned char x1 = p->x + 8;
					unsigned char y1 = p->y + 8;
					unsigned char j;

					for (j = 0; j < 8; ++j) {
						Chara *e = &chara[j + 2];

						if (x0 <= e->x && e->x <= x1
							&& y0 <= e->y && e->y <= y1) {
							p->x = x;
							p->y = y;
							break;
						}
					}
				}
			}

			// LN^̕\
			chara_draw(chara, NUMBEROF(chara), c);
		}

		// BG]f[^ݒI
		SetEndCMD();

		// t[JE^XV
		++frame;
	}
}

//NMI荞
void NMIProc(void)
{
	// ҂JnmF
	if (CheckSync()) {

		// DMA]
		SendDMA();

		// BG]R}hs
		SendCMD();

		// XN[l̍Đݒ
		ResetScroll();

		// ݒ
		DoneSync();
	}
}
