#include "nes.h"
#include "math.h"
#include "chara.h"
#include "map.h"

// C
void NesMain()
{
	unsigned char frame = 0;
	unsigned char scene = 0;

	Chara chara[] = {
		{CHR_BLUE_PENGUIN, 2,  50,  50},
		{CHR_RED_PENGUIN , 2, 150, 150},
		{CHR_SLIME , 2},
		{CHR_SLIME , 2},
		{CHR_SLIME , 2},
		{CHR_WIZARD, 2},
		{CHR_SLIME , 2},
		{CHR_SLIME , 2},
		{CHR_SLIME , 2},
		{CHR_WIZARD, 2},
	};

	// PPȔ
	InitPPU();

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// 
	srand(14, 10, 11);

	// LN^
	chara_init(chara, NUMBEROF(chara));

	// }bv
	map_init(scene);

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

	while (1) {
		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		// DMA]\񏉊
		ResetDMA();

		// Rg[mF
		CheckPad();

		{
			unsigned char c;
			unsigned char i;

			// 4Aj[VJE^
			c = (frame >> 4) & 3;

			// XvCg̕\ʒuύX
			for (i = 0; i < 2; ++i) {
				Chara *p = &chara[i];

				char vx = 0;
				char vy = 0;

				// L[͂ɂړ
				if (ButtonPress(i, BTN_RIGHT)) { vx++; p->dir = 1; }
				if (ButtonPress(i, BTN_LEFT )) { vx--; p->dir = 3; }
				if (ButtonPress(i, BTN_UP   )) { vy--; p->dir = 0; }
				if (ButtonPress(i, BTN_DOWN )) { vy++; p->dir = 2; }

				// Oɂړ
				vx += p->dx; p->dx = 0;
				vy += p->dy; p->dy = 0;

				p->x += vx;
				p->y += vy;
			}

			// Ŕ肵Ă݂ #2
			{
				Chara *p = &chara[frame & 1];
				unsigned char x0 = p->x - 8;
				unsigned char y0 = p->y - 8;
				unsigned char x1 = p->x + 8;
				unsigned char y1 = p->y + 8;

				for (i = 0; i < 8; ++i) {
					Chara *e = &chara[i + 2];

					if (x0 <= e->x && e->x <= x1
						&& y0 <= e->y && e->y <= y1) {

						p->dx = (p->x - e->x) >> 1;
						p->dy = (p->y - e->y) >> 1;
						break;
					}
				}
			}

			// LN^̕\
			chara_draw(chara, NUMBEROF(chara), c);
		}

		// BG]f[^ݒI
		SetEndCMD();

		// t[JE^XV
		++frame;
	}
}

//NMI荞
void NMIProc(void)
{
	// ҂JnmF
	if (CheckSync()) {

		// DMA]
		SendDMA();

		// BG]R}hs
		SendCMD();

		// XN[l̍Đݒ
		ResetScroll();

		// ݒ
		DoneSync();
	}
}
