#include "nes.h"
#include "chara.h"

// XvCgppbg
const char palettesp[] = {
	0x30, 0x26, 0x30, 0x01,
	0x2c, 0x16, 0x30, 0x25,
	0x0f, 0x29, 0x39, 0x1a,
	0x30, 0x3d, 0x1d, 0x00,
};

// LN^e[u
const char charatable[][4] = {
	{0x01,0x02,0x1f,0x20}, // 
	{0x03,0x04,0x21,0x22}, // ʑOi
	{0x05,0x06,0x23,0x24}, // E
	{0x07,0x08,0x25,0x26}, // EOi
	{0x09,0x0a,0x27,0x28}, // w
	{0x0b,0x0c,0x29,0x2a}, // wʑOi
};

// Aj[Ve[u
const char animetable[][4][2] = {
	{{4, 0x00}, {5,0x00}, {4, 0x00}, {5, 0x40}}, // 
	{{2, 0x40}, {3,0x40}, {2, 0x40}, {3, 0x40}}, // 
	{{0, 0x00}, {1,0x00}, {0, 0x00}, {1, 0x40}}, // 
	{{2, 0x00}, {3,0x00}, {2, 0x00}, {3, 0x00}}, // E
};

// XCLN^e[u
const char slime_chrtbl[][4] = {
	{0x0d,0x0e,0x2b,0x2c}, // 
	{0x0f,0x10,0x2d,0x2e}, // 
	{0x11,0x12,0x2f,0x30}, // 
};

// XCAj[Ve[u
const char slime_anmtbl[][4][2] = {
	{{1, 2}, {0, 2}, {1, 2}, {2, 2}}, // 
	{{1, 2}, {2, 2}, {1, 2}, {0, 2}}, // 
	{{1, 2}, {0, 2}, {1, 2}, {2, 2}}, // 
	{{1, 2}, {2, 2}, {1, 2}, {0, 2}}, // E
};

// @gLN^e[u
const char wizard_chrtbl[][4] = {
	{0x13,0x14,0x31,0x32}, // 
	{0x15,0x16,0x33,0x34}, // ʑOi
	{0x17,0x18,0x35,0x36}, // E
	{0x19,0x1a,0x37,0x38}, // EOi
	{0x1b,0x1c,0x39,0x3a}, // w
	{0x1d,0x1e,0x3b,0x3c}, // wʑOi
};

// LN^pbgwe[u
const unsigned char charapal[] = {
	0x00,
	0x01,
	0x02,
	0x03,
};

void chara_init(Chara* chara, unsigned char cnt) {

	unsigned char i;

	// pbgݒ
	SetPalette(palettesp, 1);

	// LN^̏
	FillMemory(chara, 0, sizeof(Chara)*cnt);

	for (i = 0; i < cnt; ++i) {
		Chara* p = &chara[i];

		p->chr = (i < 2)? i: CHR_NOTHING;
		p->dir = 2;
	}
}

void chara_draw(Chara* chara, unsigned char cnt, unsigned char frame) {
	unsigned char i;

	for (i = 0; i < cnt; ++i) {
		Chara *p = &chara[i];

		switch (p->chr) {
		case CHR_BLUE_PENGUIN:
		case CHR_RED_PENGUIN:
		case CHR_WIZARD:
			{
				const char* anime = animetable[p->dir][frame];
				const char* chara = (p->chr == CHR_WIZARD)?
					wizard_chrtbl[anime[0]]: charatable[anime[0]];
				unsigned char flag = anime[1] | charapal[p->chr];

				// DMA]\ݒ
				if (flag & 0x40) {
					SetDMA(p->x-8, p->y-12, chara[1], flag);
					SetDMA(p->x  , p->y-12, chara[0], flag);
					SetDMA(p->x-8, p->y- 4, chara[3], flag);
					SetDMA(p->x  , p->y- 4, chara[2], flag);

				} else {
					SetDMA(p->x-8, p->y-12, chara[0], flag);
					SetDMA(p->x  , p->y-12, chara[1], flag);
					SetDMA(p->x-8, p->y- 4, chara[2], flag);
					SetDMA(p->x  , p->y- 4, chara[3], flag);
				}
				break;
			}

		case CHR_SLIME:
			{
				const char *anime = slime_anmtbl[p->dir][frame];
				const char *chara = slime_chrtbl[anime[0]];
				unsigned char flag = anime[1];

				// DMA]\ݒ
				SetDMA(p->x-8, p->y-12, chara[0], flag);
				SetDMA(p->x  , p->y-12, chara[1], flag);
				SetDMA(p->x-8, p->y- 4, chara[2], flag);
				SetDMA(p->x  , p->y- 4, chara[3], flag);
				break;
			}
		}
	}
}
