#include "nes.h"
#include "nsd.h"
#include "math.h"
#include "sound.h"
#include "chara.h"
#include "map.h"

// C
void NesMain()
{
	unsigned char frame = 0;
	unsigned char scene = 0;
	Chara chara[10];

	// PPȔ
	InitPPU();

	// hCo
	nsd_init();

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// 
	srand(14, 10, 11);

	// LN^
	chara_init(chara, NUMBEROF(chara));

	// }bv
	map_init(scene, chara, NUMBEROF(chara));

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

	// tJn
	nsd_play_bgm(BGM_PENGUIN);

	while (1) {
		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		// DMA]\񏉊
		ResetDMA();

		// Rg[mF
		CheckPad();

		// V[ύXeXg
		if (ButtonDown(0, BTN_A)) {
			scene = (scene + 1) % 5;

			// PPȔ
			InitPPU();

			// DMA
			InitDMA();

			// LN^
			chara_init(chara, NUMBEROF(chara));

			// }bv
			map_init(scene, chara, NUMBEROF(chara));

			// wi̕\ʒuݒ
			SetScroll(0, 0);

			// `Jn(NMI荞ݗL)
			SetPPU(0x88, 0x1e);

			continue;
		}

		{
			unsigned char c;
			unsigned char i;

			// 4Aj[VJE^
			c = (frame >> 4) & 3;

			// XvCg̕\ʒuύX
			for (i = 0; i < 2; ++i) {
				Chara *p = &chara[i];
				unsigned char x = p->x;
				unsigned char y = p->y;

				char vx = 0;
				char vy = 0;

				// L[͂ɂړ
				if (ButtonPress(i, BTN_RIGHT)) { vx++; p->dir = 1; }
				if (ButtonPress(i, BTN_LEFT )) { vx--; p->dir = 3; }
				if (ButtonPress(i, BTN_UP   )) { vy--; p->dir = 0; }
				if (ButtonPress(i, BTN_DOWN )) { vy++; p->dir = 2; }

				// Oɂړ
				vx += p->dx; p->dx = 0;
				vy += p->dy; p->dy = 0;

				if (ButtonDown(i, BTN_A)) { nsd_play_se(SE_BREAK); }
				if (ButtonDown(i, BTN_B)) { nsd_play_se(SE_CLICK); }

				// n`Ŕ肵Ă݂
				{
					// LN^ʒũ}bv擾
					unsigned char ch;
					unsigned char id;
					unsigned char x = p->x + vx;
					unsigned char y = p->y + vy;

					if (vx & 0x80) x -= 4;
					else if (vx)   x += 4;

					if (vy & 0x80) y -= 4;
					else if (vy)   y += 4;

					ch = map_getmcp(x, y);
					id = GET_SYMBOL_CHR(ch);
					ch = GET_CHIP_ID(ch);

					if (ch == MCP_FIELD && id <= MAP_SYMBOL_CHR(i)) {
						p->x += vx;
						p->y += vy;
					}
				}
			}

			// LN^̕\
			chara_draw(chara, NUMBEROF(chara), c);
		}

		// BG]f[^ݒI
		SetEndCMD();

		// t[JE^XV
		++frame;
	}
}

//NMI荞
void NMIProc(void)
{
	// ҂JnmF
	if (CheckSync()) {

		// DMA]
		SendDMA();

		// BG]R}hs
		SendCMD();

		// XN[l̍Đݒ
		ResetScroll();

		// TEhhCoĂяo
		nsd_main();

		// ݒ
		DoneSync();
	}
}
