#ifndef MAP_H_INCLUDED
#define MAP_H_INCLUDED

#define BG_NAMTBL_W (SCREEN_W/8)
#define BG_NAMTBL_H (SCREEN_H/8)
#define BG_ATTR_W   8
#define BG_ATTR_H   8

#define BG_FIELD_W  (BG_NAMTBL_W/2)
#define BG_FIELD_H  (BG_NAMTBL_H/2)
#define MAP_FIELD_W 12
#define MAP_FIELD_H 11

#define MAP_SYNBOL(chr, mcp) (((chr+1) << 4)|(mcp))
#define GET_CHAR_ID(m)       ((((m) >> 4)-1) & 0x0f)
#define GET_CHIP_ID(m)       ((m) & 0x07)
#define MAP_CHAR_NO(no)      (((no)+1) << 4)
#define REMOVE_CHIP(m)       ((m) & 0xf0)
#define REMOVE_CHAR(m)       ((m) & 0x0f)

#define map_getrowcol(_x, _y) \
	_x = (_x >> 4) - (BG_FIELD_W-MAP_FIELD_W)/2; \
	_y = (_y >> 4) - (BG_FIELD_H-MAP_FIELD_H)/2;

// }bv`bvID
enum {
	MCP_FIELD = 0,
	MCP_BALL,
	MCP_GOAL,
	MCP_WALL,
	MCP_BLOCK,
	MCP_FBLOCK,
	MCP_MAX,
	MCP_FLAG_MOVE = 0x08
};

extern void map_init(char scene, Chara* chara, unsigned char cnt);
extern char map_getmcp(unsigned char x, unsigned char y);
extern void map_setmcp(unsigned char x, unsigned char y, unsigned char mcp);
extern void map_set(unsigned char x, unsigned char y, unsigned char mcp);
extern void map_move(unsigned char x, unsigned char y, unsigned char dir);

#endif
