#include "nes.h"
#include "chara.h"
#include "map.h"

// }bv`bv
const unsigned char mapchips[][4]  = {
	{0x00,0x00,0x00,0x00}, // Ƃ
	{0x18,0x19,0x1a,0x1b}, // ]{[
	{0x1c,0x1d,0x1e,0x1f}, // S[̊
	{0x14,0x15,0x16,0x17}, // 󂹂Ȃ
	{0x21,0x21,0x21,0x21}, // 󂹂ubN
	{0x21,0x21,0x21,0x21}, // ubN
};

// BGe[u
const unsigned char attrbg[] = {
	0x02, // Ƃ
	0x02, // ]{[
	0x02, // S[̊
	0x00, // 󂹂Ȃ
	0x01, // 󂹂ubN
	0x00, // ubN
};

// BGppbg
const unsigned char palettebg[] = {
	0x30, 0x31, 0x21, 0x11,
	0x30, 0x26, 0x16, 0x05,
	0x30, 0x34, 0x25, 0x15,
	0x0f, 0x31, 0x10, 0x00,
};

// }bve[u
extern const unsigned short maps[];

// Q[̃}bv
unsigned char gamemap[MAP_FIELD_H][MAP_FIELD_W];

// e[u
unsigned char attrtbl[BG_ATTR_H][BG_ATTR_W];

void map_init(char scene) {

	// pbgݒ
	SetPalette(palettebg, 0);

	// wiݒ
	FillNameTbl( 0,  0, 32, 30, 0x03);
	FillNameTbl( 3,  3, 26, 24, 0x00);
	FillNameTbl( 3,  2, 26,  1, 0x0a);
	FillNameTbl( 3, 27, 26,  1, 0x0b);
	FillNameTbl( 2,  3,  1, 24, 0x09);
	FillNameTbl(29,  3,  1, 24, 0x08);

	// wiݒ
	FillAttribute(BG1_ATTR_HADR, BG1_ATTR_LADR, 0, 64);

	// }bv̏
	FillMemory(gamemap, 0, sizeof(gamemap));

	// }bv̓ǂݎ
	{
		unsigned char* map = (unsigned char *)maps[scene];
		unsigned char x, y;
		unsigned char c = 0;
		unsigned char e = 2;

		for (y = 0; y < MAP_FIELD_H; ++y) {
			for (x = 0; x < MAP_FIELD_W; ++x) {
				unsigned char m = map[c++];
				unsigned char id;
				Chara* p;

				// }bvALN^̎擾
				id = GET_CHAR_ID(m);
				switch (id) {
				case CHR_BLUE_PENGUIN:
				case CHR_RED_PENGUIN:
					gamemap[y][x] = m;
					p = &chara[id];
					p->id = id;
					break;

				case CHR_SLIME:
				case CHR_WIZARD:
					if (e < CHARA_MAX) {
						gamemap[y][x] = GET_CHIP_ID(m)|MAP_CHAR_NO(e);
						p = &chara[e];
						p->id = e++;
						break;
					}

				default:
					gamemap[y][x] = GET_CHIP_ID(m);
					continue;
				}

				// LN^̏ʒuݒ
				p->chr = id;
				p->x = ((BG_FIELD_W-MAP_FIELD_W)/2 + x) * 16 + 8;
				p->y = ((BG_FIELD_H-MAP_FIELD_H)/2 + y) * 16 + 8;
			}
		}
	}

	// }bv񂩂wiݒ
	{
		unsigned char nam[2][MAP_FIELD_W*2];
		unsigned char x, y;

		for (y = 0; y < MAP_FIELD_H; ++y) {
			for (x = 0; x < MAP_FIELD_W; ++x) {
				unsigned char m = gamemap[y][x];
				const unsigned char *mc = mapchips[GET_CHIP_ID(m)];
				unsigned char dx = x * 2;

				nam[0][dx + 0] = mc[0];
				nam[0][dx + 1] = mc[1];
				nam[1][dx + 0] = mc[2];
				nam[1][dx + 1] = mc[3];
			}

			SetNameTbl(nam[0], (BG_NAMTBL_W-MAP_FIELD_W*2)/2, (BG_NAMTBL_H-MAP_FIELD_H*2)/2+y*2  , MAP_FIELD_W*2, 1);
			SetNameTbl(nam[1], (BG_NAMTBL_W-MAP_FIELD_W*2)/2, (BG_NAMTBL_H-MAP_FIELD_H*2)/2+y*2+1, MAP_FIELD_W*2, 1);
		}
	}

	// }bv񂩂瑮ݒ
	{
		unsigned char x, y;

		FillMemory(attrtbl, 0, sizeof(attrtbl));

		for (y = 0; y < MAP_FIELD_H; ++y) {
			unsigned char ay = y / 2 + (BG_NAMTBL_H-MAP_FIELD_H*2)/8;

			for (x = 0; x < MAP_FIELD_W; ++x) {
				unsigned char m = GET_CHIP_ID(gamemap[y][x]);
				unsigned char attr = attrbg[m];
				unsigned char ax = x / 2 + (BG_NAMTBL_W-MAP_FIELD_W*2)/8;
				unsigned char shift;

				shift  = (x & 1)? 2: 0;
				shift += (y & 1)? 4: 0;

				attrtbl[ay][ax] |= attr << shift;
			}
		}

		for (y = 0; y < BG_ATTR_H; ++y) {
			unsigned char ladr = BG1_ATTR_LADR + y * BG_ATTR_W;
			SetAttribute(BG1_ATTR_HADR, ladr, attrtbl[y], sizeof(attrtbl[0]));
		}
	}
}

// wW̃}bv擾
char map_getmcp(unsigned char x, unsigned char y) {
	x >>= 4;
	y >>= 4;

	if (x < (BG_FIELD_W-MAP_FIELD_W)/2
		|| MAP_FIELD_W + (BG_FIELD_W-MAP_FIELD_W)/2 <= x
		|| y < (BG_FIELD_H-MAP_FIELD_H)/2
		|| MAP_FIELD_H + (BG_FIELD_H-MAP_FIELD_H)/2 <= y) {
		return MCP_WALL;

	} else {
		x -= (BG_FIELD_W-MAP_FIELD_W)/2;
		y -= (BG_FIELD_H-MAP_FIELD_H)/2;
		return gamemap[y][x];
	}
}

// wW̃}bvݒ
void map_setmcp(unsigned char x, unsigned char y, unsigned char mcp) {
	x = (x >> 4) - (BG_FIELD_W-MAP_FIELD_W)/2;
	y = (y >> 4) - (BG_FIELD_H-MAP_FIELD_H)/2;
	gamemap[y][x] = mcp;
}

// wW̃}bvXVABGƑ̏s
void map_set(unsigned char x, unsigned char y, unsigned char mcp) {
	unsigned char mx;
	unsigned char my;
	const unsigned char* mc;
	unsigned int pos = screen_adr;
	unsigned char shift;

	x >>= 4;
	y >>= 4;
	mx = x - (BG_FIELD_W-MAP_FIELD_W)/2;
	my = y - (BG_FIELD_H-MAP_FIELD_H)/2;
	gamemap[my][mx] = mcp;

	mx = x << 1;
	my = y << 1;
	mcp = GET_CHIP_ID(mcp);
	mc = mapchips[mcp];
	SetCMD_2x2(mx, my, mc);

	mx = x >> 1;
	my = y >> 1;
	shift  = (x & 1)? 2: 0;
	shift += (y & 1)? 4: 0;
	mcp = (attrbg[mcp] << shift) | (attrtbl[my][mx] & ~(3 << shift));
	attrtbl[my][mx] = mcp;
	SetAttrCMD_1x1(my, mx, mcp);
}

// QɕĎwW̃}bvړABG̏s
// l͕ύXȂ
void map_move(unsigned char x, unsigned char y, unsigned char dir) {
	unsigned char mx;
	unsigned char my;
	const unsigned char* mc;
	unsigned int pos = screen_adr;
	unsigned char mcp;

	mx = (x >> 4) - (BG_FIELD_W-MAP_FIELD_W)/2;
	my = (y >> 4) - (BG_FIELD_H-MAP_FIELD_H)/2;
	mcp = gamemap[my][mx];

	x = (x >> 4) << 1;
	y = (y >> 4) << 1;
	mc = mapchips[GET_CHIP_ID(mcp)];

	if (mcp & MCP_FLAG_MOVE) {
		// Qڂ̌Ăяo
		gamemap[my][mx] = REMOVE_CHIP(mcp);

		switch (dir) {
		default:
		case 0:
			SetCMD_2x2_MoveUp(x, y - 1, mc);
			break;
		case 1:
			SetCMD_2x2_MoveRight(x + 1, y, mc);
			break;
		case 2:
			SetCMD_2x2_MoveDown(x, y + 1, mc);
			break;
		case 3:
			SetCMD_2x2_MoveLeft(x - 1, y, mc);
			break;
		}

	} else {
		// ̌Ăяo
		gamemap[my][mx] = mcp | MCP_FLAG_MOVE;

		switch (dir) {
		default:
		case 0:
			--my;
			SetCMD_2x2_MoveUp(x, y, mc);
			break;
		case 1:
			++mx;
			SetCMD_2x2_MoveRight(x, y, mc);
			break;
		case 2:
			++my;
			SetCMD_2x2_MoveDown(x, y, mc);
			break;
		case 3:
			--mx;
			SetCMD_2x2_MoveLeft(x, y, mc);
			break;
		}

		mcp = REMOVE_CHAR(mcp) | REMOVE_CHIP(gamemap[my][mx]);
		gamemap[my][mx] = mcp;
	}
}

// V{`
#define _   MCP_FIELD
#define O   MCP_BALL
#define G   MCP_GOAL
#define W   MCP_WALL
#define B   MCP_BLOCK
#define F   MCP_FBLOCK
#define P1  MAP_SYNBOL(CHR_BLUE_PENGUIN, MCP_FIELD)
#define P2  MAP_SYNBOL(CHR_RED_PENGUIN, MCP_FIELD)
#define SL  MAP_SYNBOL(CHR_SLIME, MCP_FIELD)
#define WZ  MAP_SYNBOL(CHR_WIZARD, MCP_FIELD)


// }bv
const unsigned char map01[] = {
	P1, _, _, _, _, _, _, _, _, _, _, _,
	 _, _, _, _, _, _, _, _, _, _, _, _,
	 _, _, _, _, _, _, _, _, _,SL, _, _,
	 _, _, _, _, B, _, _, _,SL, _,SL, _,
	 _, _, _, B, _, B, _, _, _,SL, _, _,
	 _, _, O, _, _, _, B, _, _, _, _, _,
	 _, _, _, _, _, _, _, B, _, _, _, _,
	 _, _, _, _, _, _, _, _, B, _, _, _,
	 _, _, _, _, _, _, _, _, _, G, _, _,
	 _, _, _, _, _, _, _, _, _, _, _, _,
	 _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map02[] = {
	P1, _, _, _, _, _, _, _, _, _, _, _,
	 _, _, _, _, O, _, _, _, _, _, _, _,
	 _, _, _, _, F, _, _, _, _, _, _, _,
	 _, _, F, F, F, F, F, _, _, _, _, _,
	 _, _, _, _, F, _, _, _, _, _, _, _,
	 _, _, _, _, F, F, F, _, _, _, _, _,
	 _, _, _, _,WZ, _, _, F, _, _, _, _,
	 _, _, _, _, _, _, _, F, _, _, _, _,
	 _, _, _, _, _, _, _, F, _, _, _, _,
	 _, _, _, _, _, G, F, _, _, _, _, _,
	 _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map03[] = {
	P1, _, _, _, _, _, _, _, _, _, _, _,
	 _, _, _, _, _, _, W, _, _, _,SL, _,
	 _, W, _, _, _, _, W, _, _,SL, O,SL,
	 _, W, _, W, W, W, W, W, _, _,SL, _,
	 _, W, _, _, _, _, W, _, _, _, _, _,
	 _, W, _, _, _, _, W, _, _, _, _, _,
	 _, _, W, _, _, W, W, W, G, _, _, _,
	 _, _, W, _, W, _, W, _, _, _, _, _,
	 _, _, W, _, W, _, W, _, _, _, _, _,
	 _, _, W, _, _, W, _, _, _, _, _, _,
	 _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map04[] = {
	P1, _, _, _, _, _, _, _, _, _, _, _,
	 _, _, _, _, B, _, _, _, _, _, _, _,
	 _, _, _, _, B, _, _, _, _, _, _, _,
	 _, _, B, B, O, B, _,WZ, _, _, _, _,
	 _, _, _, B, _, _, _, _, B, _, _, _,
	 _, _, _, B, _, _, B, _, _, _, _, _,
	 _, _, B, _, _, _, B, _, _, _, _, _,
	 _, _,WZ, _, _, B, B, B, _, _, _, _,
	 _, _, _, _, B, G, B, _, _, _, _, _,
	 _, _, _, _, _, B, _, _, _, _, _, _,
	 _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map05[] = {
	P1, _, _, _, _, _, _, _, _, _, _, _,
	 _, O, F, F, F, F, F, F, F,SL, _, _,
	 _, _, _, _, _, F, _, _, _, _, _, _,
	 _, _, _, _, _, F, _, _, _, _, _, _,
	 _, _, F, F, F, F, F, F, F, _, _, _,
	 _, _, _, _, F,WZ, F, _, _, _, _, _,
	 _, _, _, _, F, _, F, _, _, _, _, _,
	 _, _, _,SL, _, _, _, F, _, _, _, _,
	 _, _, _, F, _, _, _,SL, _, _, _, _,
	 _, _, F, _, _, _, _, _, F, _, _, _,
	 _,SL, _, _, _, _, _, _, _, G, _,P2,
};

// }bve[u
const unsigned short maps[] = {
	(unsigned short)map01,
	(unsigned short)map02,
	(unsigned short)map03,
	(unsigned short)map04,
	(unsigned short)map05,
};
