#include "nes.h"
#include "nsd.h"
#include "sound.h"
#include "clogo_ice.h"
#include "clogo_baller.h"

// BGppbg
const char title_palette[] = {
	0x30, 0x31, 0x21, 0x11,
	0x30, 0x26, 0x16, 0x05,
	0x30, 0x34, 0x25, 0x15,
	0x0f, 0x31, 0x10, 0x00,
};

// C
void __fastcall__  TitleMain(void) {
	unsigned char frame = 0;

	// PPȔ
	InitPPU();

	// hCo
	nsd_init();

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// pbgݒ
	SetPalette(title_palette, 0);

	// wiݒip^[l[e[uݒj
	FillNameTbl(0, 0, 32, 30, 0);
	SetCprNameTbl(clogo_ice   , 0,  4, clogo_ice_W   , clogo_ice_H   , 0);
	SetCprNameTbl(clogo_baller, 2, 14, clogo_baller_W, clogo_baller_H, 0);

	// wiݒ
	FillAttribute(BG1_ATTR_HADR, BG1_ATTR_LADR, 0, 64);

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

	// tJn
	nsd_play_bgm(BGM_TITLE);

	while (1) {

		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		// Rg[mF
		CheckPad();

		// X^[g{^
		if (ButtonDown(0, BTN_START)) {
			break;
		}

		// BG]R}hf[^ݒ
		if (frame == 0) {
			SetCMD((32-18)/2, 22, "PRESS START BUTTON", 18);

		} else if (frame == 128) {
			SetCMD((32-18)/2, 22, "                  ", 18);
		}

		// BG]f[^ݒI
		SetEndCMD();

		++frame;
	}
}
