#include <stdlib.h>
#include <stdio.h>
#include <string.h>

typedef union Bounds {
	struct {int x, y, w, h;} b;
	int a[4];
} Bounds;

enum {
	FLAG_COMPRESS = 0x01
};

int main(int argc, char* argv[]) {
	char *namfile = NULL;
	char *varname = NULL;
	Bounds bounds = {0};
	int flag = 0;
	int optc = 1;

	FILE *nfp = NULL;
	FILE *cfp = NULL;
	FILE *hfp = NULL;

	if (argc < 4) {
		fprintf(stderr, "Usage: %s [-c] namfile name x,y,w,h\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	if (!strncmp("-c", argv[optc], 2)) {
		++optc;
		flag |= FLAG_COMPRESS;
	}

	// ̓t@C擾
	namfile = argv[optc++];

	// ϐ擾
	varname = argv[optc++];

	// `̈擾
	{
		char *token = ",";
		char *str = argv[optc++];
		int i;

		for (i = 0; i < 4; ++i) {
			char *t = strtok(str, token);
			str = NULL;
			if (t != NULL) {
				bounds.a[i] = atoi(t);
			}
		}
	}

	{
		time_t timer;
		char cpath[MAX_PATH];
		char hpath[MAX_PATH];

		// ݓ擾
		time(&timer);

		// t@C
		snprintf(cpath, sizeof(cpath), "%s.c", varname);
		snprintf(hpath, sizeof(cpath), "%s.h", varname);

		// t@CJ
		nfp = fopen(namfile, "rb");
		cfp = fopen(cpath, "w");
		hfp = fopen(hpath, "w");

		if (nfp != NULL && cfp != NULL && hfp != NULL) {
			unsigned char buf[32 * 64] = {0};
			int i, j;

			fread(buf, sizeof(buf), 1, nfp);

			// wb_t@Co
			fprintf(hfp, "/*\n");
			fprintf(hfp, " * %s.h\n", varname);
			fprintf(hfp, " * %s", ctime(&timer));
			fprintf(hfp, " */\n");
			fprintf(hfp, "#ifndef %s_H_INCLUDED\n", varname);
			fprintf(hfp, "#define %s_H_INCLUDED\n", varname);
			fprintf(hfp, "#define %s_W %d\n", varname, bounds.b.w);
			fprintf(hfp, "#define %s_H %d\n", varname, bounds.b.h);
			fprintf(hfp, "extern const unsigned char %s[];\n", varname);
			fprintf(hfp, "#endif\n");

			// Ct@Co
			fprintf(cfp, "/*\n");
			fprintf(cfp, " * %s.c\n", varname);
			fprintf(cfp, " * %s", ctime(&timer));
			fprintf(cfp, " */\n");
			fprintf(cfp, "const unsigned char %s[] = {\n", varname);

			// w`̒𐅕Ɉk݂Ȃo
			// 00000000
			// ==------
			// |    +-- LN^ԍ 0x00`0x3f
			// +------- JԂ 0`3i0͌JԂȂŁA1`4̘Azuj
			if (flag & FLAG_COMPRESS) {
				unsigned char ch;
				int cnt;
				int i, j;
				int oflag;

				ch = buf[bounds.b.x + bounds.b.y * 32];
				cnt = 0;
				oflag = 0;

				for (j = 0; j < bounds.b.h; ++j) {
					int ofs = (bounds.b.y + j) * 32;

					for (i = 0; i < bounds.b.w; ++i) {
						unsigned char c = buf[ofs + bounds.b.x + i];

						if (ch == c) {
							++cnt;
						} else {
							while (cnt >= 4) {
								fprintf(cfp, "0x%02x,", (ch | 0xc0));
								cnt -= 4;
							}
							if (cnt > 0) {
								fprintf(cfp, "0x%02x,", (ch | (cnt - 1) << 6));
							}
							ch = c;
							cnt = 1;
							oflag = 1;
						}
					}
					if (oflag) fprintf(cfp, "\n");
					oflag = 0;
				}

				while (cnt >= 4) {
					fprintf(cfp, "0x%02x,", (ch | 0xc0));
					cnt -= 4;
					oflag = 1;
				}
				if (cnt > 0) {
					fprintf(cfp, "0x%02x,", (ch | (cnt - 1) << 6));
					oflag = 1;
				}
				if (oflag) fprintf(cfp, "\n");

			} else {
				// 񈳏k
				int i, j;

				for (j = 0; j < bounds.b.h; ++j) {
					int ofs = (bounds.b.y + j) * 32;

					for (i = 0; i < bounds.b.w; ++i) {
						unsigned char ch = buf[ofs + bounds.b.x + i];

						fprintf(cfp, "0x%02x,", ch);
					}
					fprintf(cfp, "\n");
				}
			}

			fprintf(cfp, "};\n");
		}

		if (nfp != NULL) fclose(nfp);
		if (cfp != NULL) fclose(cfp);
		if (hfp != NULL) fclose(hfp);
	}

	return EXIT_SUCCESS;
}
